SystemOrganization addCategory: #ConfigurationOfMyProject!

Object subclass: #ConfigurationOfMyProject
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfMyProject'!

!ConfigurationOfMyProject class methodsFor: 'private' stamp: 'DiegoLont 3/22/2013 16:26'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfMyProject class methodsFor: 'private' stamp: 'DiegoLont 3/22/2013 16:26'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfMyProject class methodsFor: 'metacello tool support' stamp: 'DiegoLont 3/22/2013 16:26'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfMyProject class methodsFor: 'metacello tool support' stamp: 'DiegoLont 3/22/2013 16:26'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfMyProject class methodsFor: 'loading' stamp: 'DiegoLont 3/22/2013 16:26'!
load
	"self load"
	
	self project stableVersion load! !

!ConfigurationOfMyProject class methodsFor: 'metacello tool support' stamp: 'DiegoLont 3/22/2013 16:26'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfMyProject class methodsFor: 'accessing' stamp: 'DiegoLont 3/22/2013 16:26'!
project

	^self new project! !

!ConfigurationOfMyProject class methodsFor: 'release' stamp: 'DiegoLont 3/22/2013 16:26'!
releaseToGemSource
	"self releaseToGemSource"

	(Smalltalk at: #Gofer) new
		gemsource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfMyProject class methodsFor: 'release' stamp: 'DiegoLont 3/22/2013 16:26'!
releaseToSqueakSource
	"self releaseToSqueakSource"

	(Smalltalk at: #Gofer) new
		squeaksource: 'MetacelloRepository';
		package: self name asString;
		push! !

!ConfigurationOfMyProject methodsFor: 'baselines' stamp: 'DiegoLont 3/22/2013 16:30'!
baseline010: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec author: 'DiegoLont'.
		spec repository: 'http://www.squeaksource.com/MetacelloRepository'. " fill out your repo here "
		spec 
			project: 'NeoCSV';
			project: 'SeasideRest';
			project: 'Magritte3';
			project: 'Seaside30 AddOns';
			project: 'PetitParser'.
		spec 
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'NeoCSV' 'SeasideRest' 'Magritte3' 'Seaside30 AddOns' 'PetitParser' ) ].

	self pharo14: spec.
	self pharo20: spec.! !

!ConfigurationOfMyProject methodsFor: 'symbolic versions' stamp: 'DiegoLont 3/22/2013 16:26'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOfMyProject methodsFor: 'baselines' stamp: 'DiegoLont 3/22/2013 16:29'!
pharo14: spec
	spec
		for: #'pharo1.x'
		do: [  
					spec 
			project: 'Fuel' with: [
				spec
					className: 'ConfigurationOfFuel';
					versionString: #'stable';
					loads: #( 'Core' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			project: 'NeoCSV' with: [
				spec
					className: 'ConfigurationOfNeoCSV';
					versionString: #'stable';
					loads: #( 'default' );
					repository: 'http://mc.stfx.eu/Neo' ].
		spec 
			project: 'SeasideRest' with: [
				spec
					className: 'ConfigurationOfSeasideRest';
					versionString: #'stable';
					loads: #( 'default' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec 
			project: 'Magritte3' with: [
				spec
					className: 'ConfigurationOfMagritte3';
					versionString: #'stable';
					loads: #( 'Seaside' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec
			project: 'Seaside30 AddOns' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('JSON');
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec
			project: 'PetitParser' with: [
					spec
						className: 'ConfigurationOfPetitParser';
						versionString: #'stable';
						loads: #( 'default' );
						repository: 'http://www.smalltalkhub.com/mc/Moose/PetitParser/main' ].
		spec 
			project: 'OSProces' with: [
				spec
					className: 'ConfigurationOfOSProcess';
					versionString: #'stable';
					loads: #( 'default' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ] ]
! !

!ConfigurationOfMyProject methodsFor: 'baselines' stamp: 'DiegoLont 3/22/2013 16:26'!
pharo20: spec
	spec
		for: #'pharo2.x'
		do: [
			spec 
				project: 'NeoCSV' with: [
					spec
						className: 'ConfigurationOfNeoCSV';
						versionString: #'stable';
						loads: #( 'default' );
						repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].
			spec 
				project: 'SeasideRest' with: [
					spec
						className: 'ConfigurationOfSeasideRest';
						versionString: #'stable';
						loads: #( 'default' );
						repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].
			spec 
				project: 'Magritte3' with: [
					spec
						className: 'ConfigurationOfMagritte3';
						versionString: #'stable';
						loads: #( 'Seaside' );
						repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].
		spec
			project: 'Seaside30 AddOns' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('JSON' 'JQuery' 'JQuery-UI' 'Zinc' 'Welcome');
					repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].
		spec
			project: 'PetitParser' with: [
				spec
					className: 'ConfigurationOfPetitParser';
					versionString: #'stable';
					loads: #( 'default' );
					repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ].
			spec 
				project: 'OSProces' with: [
					spec
						className: 'ConfigurationOfOSProcess';
						versionString: #'stable';
						loads: #( 'default' );
						repository: 'http://ss3.gemstone.com/ss/MetaRepoForPharo20' ] ]! !

!ConfigurationOfMyProject methodsFor: 'accessing' stamp: 'DiegoLont 3/22/2013 16:26'!
project

	^ project ifNil: [ | projectAttributes |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		project := (Smalltalk at: #MetacelloMCProject) new.
		projectAttributes := #().
		Smalltalk at: #SystemVersion ifPresent: [:cl | | versionString |
			versionString := cl current version.
			((versionString beginsWith: 'Pharo-1.0') or: [versionString beginsWith: 'PharoCore1.0'])
				ifTrue: [ projectAttributes := projectAttributes, #(#'MagritteForPharo1.0') ] ].
		project projectAttributes:  projectAttributes.
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear ]! !

!ConfigurationOfMyProject methodsFor: 'symbolic versions' stamp: 'DiegoLont 3/22/2013 16:26'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'common' version: '0.1'. 
! !

!ConfigurationOfMyProject methodsFor: 'versions' stamp: 'DiegoLont 3/22/2013 16:26'!
version010: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		
		spec description: '0.1:
- Latest changes:
	Export functionality
	'.
		spec author: 'DiegoLont'.
		spec 
			project: 'Magritte3' with: #stable.
		spec 
			package: 'Magritte-Json' with: 'Magritte-Json-DiegoLont.13';
			package: 'QC-Grease' with: 'QC-Grease-DiegoLont.3';
			package: 'QC-Log' with: 'QC-Log-DiegoLont.14';
			package: 'QC-Magritte' with: 'QC-Magritte-DiegoLont.154';
			package: 'QC-Model' with: 'QC-Model-DiegoLont.179';
			package: 'QC-Pharo' with: 'QC-Pharo-DiegoLont.1';
			package: 'QC-Web' with: 'QC-Web-DiegoLont.66';
			package: 'QCMigration-WebContfakt' with: 'QCMigration-WebContfakt-DiegoLont.24';
			package: 'Units' with: 'Units-DiegoLont.36';
			package: 'WebContfakt' with: 'WebContfakt-FriedrichDominicus.109' ]
"
QC-Language is deprecated: all classes moved to QC-Magritte 
QC-OS is deprecated: all classes moved to QC-Grease.
QC-JSon is deprecated. all classes moved to QC-Web
"! !
